<script setup>
import ContenuSupressionCarteChecklist from '@/components/checklist/contenu-supression-carte-checklist.vue'
import ContenuEditionCarteChecklist from '@/components/checklist/contenu-editon-carte-checklist.vue'
</script>

<template>
  <v-menu>
    <template v-slot:activator="{ props }">
      <v-btn icon="mdi-dots-vertical" v-bind="props"></v-btn>
    </template>

    <v-list>
      <v-dialog @afterLeave="loading = false" max-width="500">
        <template v-slot:activator="{ props: activatorProps }">
          <v-list-item
            v-bind="activatorProps"
          >
            <template #prepend>
              <v-icon color="success">mdi-pencil</v-icon>
            </template>
            <v-list-item-title>Modifier</v-list-item-title>
          </v-list-item>
        </template>
        <template v-slot:default>
          <v-card>
            <contenu-edition-carte-checklist
              v-model="tempchecklist"
              @UPDATE="updateChecklist(tempchecklist)"
              @CANCEL="isActive.value = false"
            ></contenu-edition-carte-checklist>
          </v-card>
        </template>
      </v-dialog>
      <v-dialog @afterLeave="loading = false" max-width="500">
        <template v-slot:activator="{ props: activatorProps }">
          <v-list-item
            v-bind="activatorProps"
          >
            <template #prepend>
              <v-icon color="error">mdi-delete</v-icon>
            </template>
            <v-list-item-title>Supprimmer</v-list-item-title>
          </v-list-item>
        </template>
        <template v-slot:default="{ isActive }">
          <contenu-supression-carte-checklist
            :loading="loading"
            variant="elevated"
            @DELETE="deleteChecklistAndGoToMenu"
            @CANCEL="isActive.value = false"
          ></contenu-supression-carte-checklist>
        </template>
      </v-dialog>
    </v-list>
  </v-menu>
</template>

<script>
import { useChecklistStore } from '@/stores/checklists.js'

export default {
  data() {
    return {
      loading: false
    }
  },
  props: {
    checklist: {
      type: String,
      required: true
    }
  },
  methods: {
    updateChecklist(_toUpdate) {
      this.loading = true
      useChecklistStore().updateChecklist(_toUpdate).then(() => {
        this.loading = false
      })
    },
    deleteChecklistAndGoToMenu() {
      this.loading = true
      useChecklistStore().deleteChecklist(this.checklist.checklistId).then(() => {
        this.loading = false
        this.$router.push({ name: 'home'})
      })
    }
  },
}
</script>